function y = J_2d(a, b, freq1, freq2, dH, weight)
%
% y = J(a, b, freq1, freq2, dH, weight)
%
% Computes the value of

%          -                                     2
% J(a,b) = > weight(k) | dH(k) - H(a,b,freq(k)) |
%          - 
% where k is a pair of indices.

% BD 19.02.2002

e1 = exp(-j*freq1);
e2 = exp(-j*freq2);
vb = polyval_2d(b, e1, e2);
va = polyval_2d(a, e1, e2);

y = sum(sum( weight .* abs( dH - vb./va ).^2 )) / length(freq1) / length(freq2);
