function [gr, Hes] = Jgradhes(a, b, freq, dH, weight)

% BD 3.02.2002

n = length(a);
n1 = n+1;
m1 = length(b);
m2 = m1 + 1;
m = m1 - 1;
nm1 = n + m1;
nm = max([2*n m+n]);

a = a(:)';
b = b(:)';

aa = fliplr( [1 a] );
bb = fliplr( b );

L = length(freq);

gr = zeros(nm1,1);

z = cos(freq) - j*sin(freq);
Aw = polyval(aa,z);
Bw = polyval(bb,z);
Hw = Bw ./ Aw;
Ew = dH - Hw;
cEAw = conj(Ew) ./ Aw;

if nargout == 2
  Hes = zeros(nm1);
  aAw2 = abs(Aw).^2;
  HAw = Hw ./ Aw;
  aHAw2 = abs(HAw).^2;
  HaAw2 = Hw ./ aAw2;
end

for i = 1 : L
  ww = weight(i);
  expw = exp( -j*freq(i)*(0:nm)' );
  gr(1:m1) = gr(1:m1) - 2 * ww * real( cEAw(i) * expw(1:m1) );
  gr(m2:end) = gr(m2:end) + 2 * ww * real( cEAw(i) * Hw(i) * expw(2:n1) );

  if nargout == 2
    cosw = real( expw );
    Hes(1:m1, 1:m1) = Hes(1:m1,1:m1) + toeplitz( 2 * ww * cosw(1:m1) / aAw2(i) );
    hh = 4 * ww * real( cEAw(i) * HAw(i) * expw(3:2*n+1) );
    Hes(m2:end,m2:end) = Hes(m2:end,m2:end) + ...
                         toeplitz( 2 * ww * aHAw2(i) * cosw(1:n) ) + ...
			 hankel( hh(1:n), hh(n:end) );

    t1 = 2 * ww * real( HaAw2(i) * expw(2:n1) );
    t2 = 2 * ww * real( HaAw2(i) * conj(expw(1:m)) );
    t2 = [ t1(1); t2 ];
    hh = 2 * ww * real( cEAw(i) / Aw(i) * expw(2:nm1) );
    Hes(m2:end,1:m1) = Hes(m2:end,1:m1) - ...
		       toeplitz( t1, t2 ) + ...
		       hankel( hh(1:n), hh(n:end) );
  end
end

if nargout == 2
  Hes(1:m1,m2:end) = Hes(m2:end,1:m1)';
end

