function y = Jp_2d(a, b, freq1, freq2, dH, weight, p)
%
% y = J(a, b, freq1, freq2, dH, weight, p)
%
% Computes the value of

%          -                                     p
% J(a,b) = > weight(k) | dH(k) - H(a,b,freq(k)) |
%          - 
% where k is a pair of indices.

% BD 03.11.2003

e1 = exp(-j*freq1);
e2 = exp(-j*freq2);
vb = polyval_2d(b, e1, e2);
va = polyval_2d(a, e1, e2);
E = abs( dH - vb./va );

if p == inf
  y = max(max( weight.*E ));
else
  y = sum(sum( weight .* E.^p )); % / length(freq1) / length(freq2);
end
