function C = block_conv(A, B)
% multiply two polynomials with matrix coefficients

% BD 23.11.2004

Na = length(A);
Nb = length(B);
[ma,pa] = size(A{1});
[mb,pb] = size(B{1});
if pa ~= mb
  error('Wrong sizes')
end

Nc = Na+Nb-1;
for n = 1 : Nc
  C{n} = zeros(ma,pb);
  for k = max(1,n-Nb+1) : min(Na,n)
    C{n} = C{n} + A{k} * B{n-k+1};
  end
end
