% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2007

% Example 2.12: minimum value of a trigonometric polynomial on the unit circle

% Vector of (distinct) coefficients
R = [6 -3 2];

% Pick your choice of a function
my_choice = 0;

switch my_choice
  case 0,     % the program from section 2.12.1
    mu = minpol1(R);
    
  case 1,     % a more general program for multidimensional polynomials
    [Q, smallest_eig, mu] =  most_pos_Gram(R, length(R)-1);
    
  case 2,     % CVX program
    mu = minpol_cvx(R);
    
  case 3,     % Gram-pair parameterization (sec. 2.8.3)
    mu = minpol1_g2(R);
end

mu

