% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2007

% Example 3.16: most positive Gram matrix associated with a multivariate
% trigonometric polynomial

% Pick your choice of coefficient presentation
my_choice = 1;

switch my_choice
  case 0,     % polynomial given in full symmetric form
    R = [-5     4     1
         -8    18     2
          1    38     1
          2    18    -8
          1     4    -5];
    
    [Q, smallest_eig] =  most_pos_Gram(R)
    
  case 1,     % polynomial given with causal part (coefficients belonging to a half plane)
    R = [38 18 4 1 2 1 -8 -5]';
    nR = [2 1];  % degree
    [Q, smallest_eig] =  most_pos_Gram(R, nR)
end

