% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2007

% Example 3.38: minimum value and most positive Gram matrix associated with
% a multivariate trigonometric polynomial with matrix coefficients

use_cvx = 0;  % set to 1 for calling a CVX-based function

% Polynomial: stored as an array of cells, each cell representing a matrix
% coefficient; all coefficients are stored
nR = [1 1];   % degree of the polynomial
for i1 = 1 : 2*nR(1)+1
  for i2 = 1 : 2*nR(2)+1
    R{i1,i2} = zeros(2);
  end
end
R{2,2} = [4 0; 0 4];
R{1,2} = [1 0; 0 0];
R{3,2} = R{1,2}';
R{2,1} = [0 0; 0 1];
R{2,3} = R{2,1}';
R{1,1} = [0 -1; 0 0];
R{3,3} = R{1,1}';

% find solution with SeDuMi-based function
if use_cvx  % CVX-based function, computes only minimum value of smallest eigenvalue
  Rvec = pol_cs2vec(R);
  mu = minpol_cvx(Rvec, nR ,2);
else   % SeDuMi-based function
  [Q, smallest_eig, mu] = most_pos_Gram_M(R, nR)
end
