% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2017 (second edition)

% Example 4.31: Hinf norm of a 2D FIR filter

% Options
use_cvx = 0;      % set to 1 to use CVX version
nplus = [0 0];    % set to e.g. [1 1] for a potentially better approximation,
                  % but increasing the complexity

% the 2D filter
H = [ 0  1  1  1
      0  0  3  0
      0  3  0  0
      1  0  0  0 ];

% Compute the norm
if use_cvx
  hinf_norm = fir2_hinf_norm_cvx(H, nplus)
else
  hinf_norm = fir2_hinf_norm(H, nplus)
end