% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2017 (second edition)

% Example 5.10: robust FIR Hinf deconvolution

% channel model, a polytope whose vertices are
G{1}{1} = 1; G{1}{2} = 0.3; G{1}{3} = 4.5; G{1}{4} = -0.14487; G{1}{5} = 1.6837;
G{2}{1} = 1; G{2}{2} = 0.3; G{2}{3} = 4.8; G{2}{4} = -0.14487; G{2}{5} = 1.6837;
G{3}{1} = 1; G{3}{2} = 0.4; G{3}{3} = 4.5; G{3}{4} = -0.14487; G{3}{5} = 1.6837;
G{4}{1} = 1; G{4}{2} = 0.4; G{4}{3} = 4.8; G{4}{4} = -0.14487; G{4}{5} = 1.6837;

% desired model - delay z^{-2}
D{1} = 0;
D{2} = 0;
D{3} = 1;

% filter design data
Nx = 6;        % degree

% design 
[X, err, E] = fir_deconv_inf_rob(G, D, Nx);
if size(G{1,1},1) == 1    % make vectors instead of cells
  x = zeros(Nx+1,1);
  for k = 1 : Nx+1
    x(k) = X{k}(1);
  end
end

% compute error norms in vertices
for i = 1 : length(E)
  errv(i) = norm_fir_mimo_brl(E{i});
end

worst_case_error = max(errv)
