% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2017 (second edition)

% Example 5.11: 2D FIR deconvolution (standard setup)

use_cvx = 0;       % set to 1 for CVX version

% channel model
G = [ 8   0.1   0.1   0.1
      0   0     0.3   0
      0   0.3   0     0
      0.1 0     0     0 ];
% desired model is "delay" z1^0 z2^0 (approximated FIR inverse actually computed)
d = [0 0];

% filter design data
Nx = [2 2];     % degree
nplus = [0 0];  % extra degree for relaxation

% build cells for the deconvolution problem
D = zeros(size(G));   % put delay in matrix form
D(d(1)+1,d(2)+1) = 1;

% design
if use_cvx
  [X, hinf_err, E] = fir2_deconv_hinf_cvx(G, D, Nx, nplus);
else
  [X, hinf_err, E] = fir2_deconv_hinf(G, D, Nx, nplus);
  % make X matrix
  x = zeros(Nx+1);
  for i1 = 1 : Nx(1)+1
    for i2 = 1 : Nx(2)+1
      x(i1,i2) = X{i1,i2};
    end
  end
end
hinf_err
