% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2007

% Example 6.3: two-channel complex symmetric filter bank

% Design data
n = 29;       % filter order (must be odd)
nreg = 1;     % number of roots at -1
ws = 0.55;    % stopband edge (normalized frequency)
gs = 10^(-21/20)/sqrt(2);  % stopband error bound (set to 1 for no constraints)

% Design program
h = cocof(n, ws, gs, nreg);

% Draw frequency response
[H,w] = freqz(h);
H = 20*log10(abs(H));
w = w / pi;
plot(w, H)              % first filter
hold on
plot(w(end:-1:1), H)   % second filter
axis([0 1 -60 10])
grid
xlabel('Frequency (\omega / \pi)');
ylabel('Magnitude (dB)');
