% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2007

% Example 7.15: robust stability test for systems depending polynomially on
% some bounded parameters

b = 2.99999999;   % parameter of the system: the system is stable for b in (-3,3)

A = [ -3  -18  -3     % matrix of coefficients of transformed system
       3   6    3
       0   0    0
       b  2*b   b
      -b  2*b  -b];

% Call test based on Positivstellensatz and report result
is_stable = stab_2d_psatz(A);
fprintf('Positivstellensatz test: system is ')
if is_stable
  fprintf('stable\n')
else
  fprintf('NOT stable\n')
end
    