% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2007

% Example 7.6: 2D stability test using Positivstellensatz


err = 2e-4;  % give small positive values to this parameter

% coefficient matrix
A = [ 1      -0.8    0.5
     -0.5     0.4   -0.25
      1-err  -0.8    0.5];

% Call test based on Positivstellensatz and report result
is_stable = stab_2d_psatz(A);
fprintf('Positivstellensatz test: system is ')
if is_stable
  fprintf('stable\n')
else
  fprintf('NOT stable\n')
end

% Call test based on "squaring" (see ex. 7.1) and report result
is_stable = stab_nd_syst(A);
fprintf('Squaring & sum-of-squares test: system is ')
if is_stable
  fprintf('stable\n')
else
  fprintf('NOT stable\n')
end
