% Programs for the book
% "Positive Trigonometric Polynomials and Signal Processing Applications"
% by Bogdan Dumitrescu, Springer 2007

% Example 8.3: magnitude design of lowpass IIR filters

% Design data
m = 7;     % numerator order
n = 4;     % denominator order
wp = 0.2;  % passband edge
ws = 0.25; % stopband edge
gp = 0.1;  % passband error bound
gs = 0.01; % stopband error bound
epss = 0;  % change to 0.02 to decrease pole radius (with m=20)
           % Warning: with epss>0, the results are different from those
           % reported in the book - I have no explanation why

% Design filter
[b,a] = iir_lowpass_mag(m, n, wp, ws, gp, gs, epss);

% Draw frequency response
freqz_lowpass_mask(b, a, wp, ws, gp, gs, 1)
axis([0 1 -60 10])
xlabel('Frequency (\omega / \pi)');
ylabel('Magnitude (dB)');

% compute pole radius
max_pole_radius = max(abs(roots(a)))
