function k = exp2ind_halfsp(vexp, ndeg)
% Transforms the exponent vexp into an index,
% as ordering a half space polynomial of degree ndeg

% BD 10.12.2003

nd = length(ndeg);        % number of dimensions
nd2 = 2*ndeg - 1;
Cp = cumprod(nd2);
No = (Cp(end)-1)/2;       % number of coefs out of half space
Cp = [1 Cp(1:end-1)];
k = Cp * (vexp(:)+ndeg(:)-1) - No + 1;  % index starts from 1
