function k = exp2ind_nd(vexp, ndeg)
% Transforms the exponent vexp into an index,
% for a polynomial of degree ndeg

% BD 11.12.2003

nd = length(ndeg);        % number of dimensions
Cp = cumprod(ndeg+1);
Cp = [1 Cp(1:end-1)];
k = Cp * (vexp(:)-1) + 1;  % index starts from 1
