function polcoef = fm_charpoly(A1,A2,A3)
% Compute coefficients characteristic polynomial for Fornasini Marchesini model

% BD 13.02.2006

nb = size(A1,1);
n1 = nb + 1;
w = 2*pi/n1 * (0:nb)';
x = exp( j * w * (0:nb) );

A = zeros(n1*n1);
b = zeros(n1*n1,1);

k = 1;
for i1 = 1 : n1
  for i2 = 1 : n1
    b(k) = det(eye(nb) - A1*x(2,i1) - A2*x(2,i2) - A3*x(2,i1)*x(2,i2));
    A(k,:) = kron( x(i2,:), x(i1,:) );
    k = k+1;
  end
end

polcoef = real(mat( A\b ));