function [Hout, f1, f2] = freqz_2d( b, a, L1, L2 )
%
% Compute frequency response of 2D filter
%

% BD 20.02.2002

if nargin < 3
  L1 = 99;
  L2 = 99;
end

f1 = -1 : 1/L1 : 1;
f2 = -1 : 1/L2 : 1;

[n1,n2] = size(a);
[m1,m2] = size(b);

Aw = polyval_2d(a, exp(-j*pi*f1), exp(-j*pi*f2));
Bw = polyval_2d(b, exp(-j*pi*f1), exp(-j*pi*f2));
H = Bw./Aw;

if nargout == 0		% draw
  mesh(f1,f2,20*log10(abs(H)));
  xlabel('Frequency'), ylabel('Frequency'), zlabel('Magnitude')
  return
end
Hout = H;
