function freqz_lowpass_mask(b, a, wp, ws, dp, ds, dB)
% Plot the frequency response of a lowpass IIR filter,
% together with magnitude bounds (spectral mask)

% BD 25.01.2006, modified 24.07.2006

if nargin < 7
  dB = 0;
end

[H,w] = freqz(b,a);
if dB
  plot(w/pi, 20 * log10(abs(H)))
  dp1 = 20*log10(1+dp);
  dp2 = 20*log10(1-dp);
  ds = 20*log10(ds);
  loww = -100;
else
  plot(w/pi, abs(H))
  dp1 = 1 + dp;
  dp2 = 1 - dp;
  loww = 0;
end

hold on
plot( [0 wp wp], [dp2 dp2 loww], '--' );
plot( [0 ws ws 1], [dp1 dp1 ds ds], '--');
hold off
