function iexp = ind2exp_nd(iv, ndeg)
% Transforms index in a vector of (scalar) coefficients into exponent,
% for a polynomial of degree ndeg

% BD 14.01.2009

nd = length(ndeg);        % number of dimensions
iexp = zeros(1,nd);
Cp = cumprod(ndeg+1);
iv = iv - 1;              % indices start from 1
for i = nd-1 : -1 : 1
  iexp(i+1) = floor( iv / Cp(i) );
  iv = iv - iexp(i+1) * Cp(i);
end
iexp(1) = iv;

