function [alpha_out, crit]=min_gold(weight,d,w,b,a,delta_b,delta_a,alpha_in);
% alpha_out=min_gold(weight,d,w,b,a,delta_b,delta_a,alpha_in);

% Riitta Niemist 29.1.2002

eps=1e-5;


N=max(round(log(eps/alpha_in)/log(2/3)),2);

phi=(sqrt(5)-1)/2;

alpha(1) = 0;
alpha(4) = alpha_in;
alpha(3) = alpha(1) + phi * ( alpha(4) - alpha(1) );
alpha(2) = alpha(1) + phi * ( alpha(3) - alpha(1) );

cost(1) = J2(weight,d,w,b+alpha(1)*delta_b,[1 a+alpha(1)*delta_a]);
cost(2) = J2(weight,d,w,b+alpha(2)*delta_b,[1 a+alpha(2)*delta_a]);
cost(3) = J2(weight,d,w,b+alpha(3)*delta_b,[1 a+alpha(3)*delta_a]);
cost(4) = J2(weight,d,w,b+alpha(4)*delta_b,[1 a+alpha(4)*delta_a]);

for n=1:N,
  
  [val,i]=min(cost);
  
  if (i==1) | (i==2);
    alpha(4)=alpha(3);
    alpha(3)=alpha(2);
    alpha(2)= alpha(1) + phi * ( alpha(3) - alpha(1) );
    cost(4) = cost(3);
    cost(3) = cost(2);
    cost(2)=J2(weight,d,w,b+alpha(2)*delta_b,[1 a+alpha(2)*delta_a]);
  else
    alpha(1)=alpha(2);
    alpha(2)=alpha(3);
    alpha(3) = alpha(1) + phi * ( alpha(4) - alpha(1) );
    cost(1)=cost(2);
    cost(2)=cost(3);
    cost(3)=J2(weight,d,w,b+alpha(3)*delta_b,[1 a+alpha(3)*delta_a]);
  end
end
alpha_out=alpha(i);
crit = cost(i);
