function m = minpol1_pos3poly(R)

% m = minpol1_pos3poly(R)
%
% Compute the minimum value on the unit circle of a trigonometric polynomial, using POS3POLY
% Input:
%   R       - vector of distinct coefficients, starting with free term
% Output:
%   m       - the minimum

% BD 18.08.2016

n = length(R);    % length of the polynomial

p = [n-1 1];      % degree and coefficients size (scalars)
ptype = [];
if ~isreal(R)     % complex data
  ptype.complex_coef = 1;
end
cvx_begin
  variable m;
  maximize( m )
  subject to
    m*eye(n,1) + sos_pol(p, ptype) == R; % equality constraints
cvx_end
