function m = minpold_pos3poly(n, R)

% m = minpold_pos3poly(R)
%
% Compute the minimum value on the unit circle of a multidimensional trigonometric polynomial, using POS3POLY
% Input:
%   n       - degree of the polyomial
%   R       - vector of distinct coefficients from a halfspace
% Output:
%   m       - the minimum

% BD 23.08.2016

R = R(:);     % force column vector
p = [n 1];    % degree and coefficients size (scalars)
ptype = [];
if ~isreal(R) % complex data
  ptype.complex_coef = 1;
end
cvx_begin
  variable m;
  maximize( m )
  subject to
    m*eye( (prod(2*n+1)+1)/2, 1 ) + sos_pol(p, ptype) == R; % equality constraints
cvx_end
