function x = norm_fir_2(A,B)

% If 1 argument, compute the 2-norm of the FIR MIMO system
% If 2 arguments, compute the 2-norm of their difference

% BD 25.11.2004

na = length(A);
if nargin == 2
  nb = length(B);
  if nb > na
    C=A; A=B; B=C;
    n=na; na=nb; nb=n;
  end
  for n = 1 : na
    A{n} = A{n} - B{n};
  end
end

x = 0;
for n = 1 : na
  x = x + sum(sum(A{n}.*A{n}));
end
x = sqrt(x);
